Duplicate spell checking dictionaries for every entry

Bug #66015 reported by Ralf Nieuwenhuijsen on 2006-10-13
174
This bug affects 28 people
Affects Status Importance Assigned to Milestone
Mozilla Firefox
Fix Released
Medium
3.5
Fix Released
Undecided
Unassigned
Mozilla Thunderbird
Fix Released
Medium
One Hundred Papercuts
Low
Unassigned
dictionaries-common (Debian)
Fix Released
Unknown
dictionaries-common (Ubuntu)
Low
Unassigned
firefox (Ubuntu)
Low
Mozilla Bugs
firefox-3.0 (Ubuntu)
Low
Unassigned
firefox-3.5 (Ubuntu)
Low
Unassigned
thunderbird (Ubuntu)
Low
Unassigned

Bug Description

If you right click on a Firefox text area, you can select which language to use for spell checking. In this list I see:

  + en_us
  + English / Verenigde Staten
  + en_uk
  + English / Verenigd Koninkrijk

As you can see they both us-en and uk-en show up translated to my language (Dutch) and as an acronym. They seem to behave the same though.

Perhaps this is an issue with translated dictionary names, perhaps this is just an issue of having differently named packages installed containing the same dictionaries. I'm not really sure where they get their dictionaries from.

I had to install a dutch dictionary using an add-on: it was not installed by default, even though the rest of my desktop was translated to Dutch. But I'll post that as a seperate bug.

Wim van der Meer (wim-zaf) wrote :

I am not aware of spell-checking abilities in Firefox, however, if you are referring to localization, you will indeed need to install the FIrefox language/region package, since it is not a program controlled by the desktop environment.

If you are rferring to spell checking abilities in Firefox, could you plese enlighten me and tell me how you have set that up, because it doesn't seem to be turned on be default.

Also, UK and USA English have some minor differences in spelling, that is why there are seperate localizations / dictionaries for these languages.

Changed in firefox:
assignee: nobody → wim-zaf
status: Unconfirmed → Needs Info
Daniel Robitaille (robitaille) wrote :

I can confirm these duplicate dictonaries with Firefox in Edgy. In my case, I have the en_CA locale, and I have the same 4 options: "en_US", "English/United States", "en_GB" and "English/United Kingdon"; but these 4 options should be really 2.

Wim ==> Firefox 2 has spell-checking when you enter text in a online form. For a good example go at google.com, enter a search term, then right click on the text area and you will have the chance to spell check what you just typed. That's new with Firefox 2, and it works in Edgy by default.

Ralf ==> US english and UK english are different for some words, thus the 2 dictionaries. A word like color (US) and colour (British) have different spelling in each country, thus depending on your country or background, an user would need one or the other english dictionary.

Changed in firefox:
status: Needs Info → Confirmed
importance: Undecided → Low
Wim van der Meer (wim-zaf) wrote :

Daniel, thanks for clearing that up!

Changed in firefox:
assignee: wim-zaf → nobody

Yes, I know English and American are different. My bug report is about
the fact that I have 4 choices to select out of 2 languages. It should
be two dictionaries, not four. Again, like I said before, the list of
dictionaries I can choose from:

 + en_us
 + English / Verenigde Staten
 + en_uk
 + English / Verenigd Koninkrijk

I don't really understand what the fact that there are differences
between US-English and UK-English have got to do with the fact that
there are four dictionaries.

@Wim vd Meer:
About every claim you make here is incorrect.

"I am not aware of spell-checking abilities in Firefox"
Then you must be a great English language speller or oblivious to the
red underlinings of certain words, or you are running Dapper. The
current test version is Edgy. And this bug is obviously about the
Firefox 2 version installed with Edgy.

"however, if you are referring to localization, you will indeed need
to install the
FIrefox language/region package, since it is not a program controlled by
the desktop environment."

No, firefox language/region _is_ controlled by the desktop
environment. They install language packs for all installed languages
and based on the language-environment variable (a shell-variable they
setup during login) each program, including Firefox, uses the correct
language pack or rosetta-template. In other words, if I login to an
English desktop i get an English firefox. I have never needed to
install any language packs by hand.

So, Willem if you have any more questions not about the fact that I
see 4 instead of 2 dictionaries, please email me personally, or put up
your question on a forum. This is a bug report about the availability
of FOUR instead of TWO dictionaries. Meant to be read by the packger
so he/she can fix this.

I just reread my comment. It actually sounds very harsh: not my
intention, sorry. Guess the spell checker doesn't check for that :-(

Bug still valid with Feisty herd-4.

Also, the local language spelling pack is not installed by default.
I have english spell checker, but not dutch, which is the language of my desktop. The interface of Firefox does use a dutch language pack.

So the spell-checker still needs some integration-love.
Perhaps Debian has fixes for this? I assume Firefox is no longer synced with Debian because their version is no longer 'officially supported' by Mozilla and the Ubuntu version is.

Alexander Sack (asac) wrote :

actually I don't understand the issue here. Can you try to rephrase and state a simple testcase?

Changed in firefox:
assignee: nobody → mozillateam
status: Confirmed → Needs Info

Sure, Alexander!
This is the test-case:

  1. Please click on the 'add a comment' on this bug-report
  2. Right click on the comment-area
  3. Select the Languages submenu
  4. Type your options

If I do this, I get:

  en_US
  English/United States
  en_ZA
  en_GB
  English/United Kingdom
  English/South Africa

Like I said, each dictionary (UK,US,SA) has duplicate menu options. The en_US, en_ZA and en_GB options shouldn't be there.

What do you get?

The other issue I raised, about missing dictionaries for the current locale, should be a separate bug report.

Therefor I created one:
https://launchpad.net/ubuntu/+source/firefox/+bug/86400

Why is this back on 'needs info' ?

Can someone please confirm this? Its easy to test and see...

Changed in firefox:
status: Needs Info → Confirmed
David Farning (dfarning) on 2007-02-24
Changed in firefox:
assignee: mozillateam → mozilla-bugs

Bug still valid In Gutsy

Alexander Sack (asac) wrote :

Triagers: This needs upstream triage. Please look for upstream bugs. There are likely duplicates posted in bugzilla.mozilla.org.

Thanks,

 - Alexander

Karol Ptasinski (karolpt) wrote :

I also get duplicates. I did not install any of these dictionaries. Running norwegian nb-NO locale. Other dictionaries installed have no duplicates.

My duplicates:
  en_US
  English/United States
  en_ZA
  en_GB
  English/United Kingdom
  English/South Africa

mati (mati-wroc) wrote :

Alexander Sack: I couldn't find anything in bugzilla.mozilla.org. Perhaps it's only Ubuntu locales problem?

(it could be related to https://bugs.launchpad.net/ubuntu/+source/language-support-en/+bug/157921 ?)

mati (mati-wroc) wrote :

It's also worth to notice that the problem isn't related only to English (see "pl_PL" and "Polski / Polska" in my screenshot).

On Wed, Jul 02, 2008 at 03:54:46PM -0000, mati wrote:
> Alexander Sack: I couldn't find anything in bugzilla.mozilla.org.
> Perhaps it's only Ubuntu locales problem?
>
> (it could be related to https://bugs.launchpad.net/ubuntu/+source
> /language-support-en/+bug/157921 ?)
>
> ** Attachment added: "Spellchecker language selection in Firefox"
> http://launchpadlibrarian.net/15761819/firefox-spellchecker.png
>

This is a ubuntu issue. please search bugs of
language-support-writing-en package for duplicate and mark accordingly.

 - Alexander

The last comment was made almost a year ago and this bug is still present in Ubuntu 9.04. I was wondering if there is any perspective to get this fixed? It's rather annoying for those who frequently change the language for Firefox' spell checker.

Simosito (simosito) wrote :

The solution is to rename the dictionary files (i.e. en_GB.aff, en_GB.diff) replacing the underscore ("_") with a "-" and deleting the link.
However doing this will cause (at least had caused on my Ubuntu 9.04+OOo 3.0.1) OpenOffice not to find the dictionaries.

mati (mati-wroc) on 2009-06-03
summary: - Duplicate spell checking dictionaries for EN/UK and EN/US
+ Duplicate spell checking dictionaries for every entry
Mat Tomaszewski (mat.t.) on 2009-06-11
Changed in hundredpapercuts:
importance: Undecided → Low
status: New → Confirmed
Daniel Schierbeck (dasch) wrote :

I use an English / US Ubuntu install, and have only installed language-support-da, yet this is my list of options in Firefox:
 - en_US
 - English / United States
 - en_ZA
 - en_GB
 - English / United Kingdom
 - en_AU
 - da_DK
 - English / Australia

Besides "en_GB" not being usable at all, I'm interested in neither South African, British nor Australian English. I'd like to just see "English" and "Danish" (the countries obviously don't matter if I've only installed en_US).

I constantly need to switch between English and Danish, and this is very detrimental to the experience.

Bernard Decock (decockbernard) wrote :

I have been struggling with the different kind of spellcheckers too. First of all for my native language (Nederlands = dutch), we have 2 spellcheckers : Nederlands-Belgium and Nederlands-Nederland. One can select in OpenOffice Nederlands-Belgium (installed by default when you select the timezone = Brussels), but there is no spell-checker available for Nederlands-Belgium (one has to select Nederlands-Nederland). When I convert word-documents .doc into .odt-documents,
all the words marked as "Nederlands" are set into Nederlands-Belgium => No spellchecking. I have to convert all selected words into Nederlands-Nederland! (I you are working with documents with texts in different languages in one document, I can assure you, it's a hell of a job to enable spellcheck for my proper language!

Changed in hundredpapercuts:
milestone: none → round-7
milestone: round-7 → round-8
Changed in hundredpapercuts:
milestone: round-8 → round-9
Andrew (and471) wrote :

Here is the current issue:

In the directory /usr/share/myspell/dicts there is the situation that when a language is installed, (for example English [United Kingdom]) the file 'en_GB.dic' is created, but also a symlink to it is created called 'en-GB.dic'

The trouble is OpenOffice looks for 'en_GB.dic' and firefox looks for 'en-GB.dic' so we can't just delete either one. The reason firefox adds these duplicate entries is because of these symlinks.

I think the trouble is that Firefox is look for the entries with a hyphen between them, which is not the standard naming of these myspell dictionary files so firefox shall have to be patched.

Sigurd Gartmann (sigurdga) wrote :

In my case, in addition to the three english language variants which have duplicates, I have en_ZA and nb_NO language files (without en-ZA or nb-NO). And these are not written out as i.e. "Norsk, bokmål".

In my opinion we have two issues here:

(1) firefox recognizes both kinds of entries (en_US AND en-US, where the latter is non-standard). This is also the title of this bug (except that in my case, I do not have duplicates for every entry).

(2) firefox does not recognize (and write out the long names of) the files with undercore separating the language and location.

I have seen this for both firefox 3.0 and 3.5 on my jaunty setup.

I guess (2) can be fixed by changing the hypthen to a underscore in toolkit/content/inlineSpellCheckUI.js in the xulrunner. However I have not been able to find the lines for (1), maybe it's deeper in the cpp code.

(This was my first time trying out debuild pbuilder, and I am not even sure how to make a patch for (2) in xulrunner. Firefox is kind of big as a start. However I was tempted by the papercuts report on the planets.)

Andrew (and471) wrote :

I have just wrote a piece of code that I think will solve our papaercut. Basically before Firefox creates the menu items (the same ones that could be duplicates) my piece of code removes all entries in that list containing "-".

I shall test it out and if it works, write a debdiff for it

Andrew (and471) wrote :

Well I couldn't get it to work but for the person who wants to take up the challenge I think the key is to place the code:

    for (i in list) {
    if (list[i].indexOf("_") != -1) {
        list.splice(x, 1)
      }
    }

at line 204 in toolkit/content/toolkit/content/inlineSpellCheckUI.js

This should remove the items in the list that have an underscore in them, however I couldn't get it to work

Micah Gersten (micahg) wrote :

Firefox 2 is EOL.

Changed in firefox (Ubuntu):
status: Confirmed → Won't Fix
Micah Gersten (micahg) wrote :

Firefox 3.0 is only receiving Security Updates and major bug fixes at this point.

Changed in firefox-3.0 (Ubuntu):
status: New → Won't Fix
importance: Undecided → Low
Micah Gersten (micahg) wrote :

This seems like something that should be fixed upstream. I'm trying to find the upstream bug for this if one exists.

Changed in firefox-3.5 (Ubuntu):
importance: Undecided → Low
status: New → Triaged
era (era) wrote :

I think you want list.splice(i, 1) not (x, 1)

Andrew (and471) wrote :

Sorry, yeah I tried that also but it still didn't work

era (era) wrote :

Currently (at least in FF-3.0) /usr/lib/firefox-3.0.13/dictionaries is a symlink to ../../share/myspell/dicts which contains both the Firefox lg-TR and the proper ISO lg_TR language/territory pairs. Perhaps it would make more sense to make dictionaries a proper directory containing symlinks for each individual dictionary according to Firefox's (AFAICT broken, or at least incompatible) conventions? (Then how do you keep it populated, are there hooks you can run to update when a dictionary is installed or removed?)

The other fix I suppose would be to change the tr-LG separator in inlineSpellCheckUI.js from hyphen to underscore e.g. if running on Linux. This I suppose might make sense to offer upstream as a patch. I don't think they'd take the patch suggested by rugby471 since it's apparently merely a workaround for a packaging problem. On the other hand, maybe this fix too is merely an Ubuntu packaging issue, and should stay as an Ubuntu patch.

FWIW this file seems to end up being distributed in /usr/lib/xulrunner-1.9.0.13/chrome/toolkit.jar -- should a bug task be added for xulrunner?

(How do other distros tackle this?)

era (era) wrote :

Attached is a trivial monkey patch against an installed toolkit.jar which simply replaces the separator between the language and region codes from dash to underscore -- just unpack the jar file, patch -p0 <inlineSpellCheck.patch, zip back together and replace the system version with the result.

Still remaining to do is fix each myspell-${lg}-${tr} package to not create the now (hopefully) unnecessary lg-TR symlinks into /usr/share/myspell/dicts -- this is all based on the assumption that only Firefox ever needed them.

(I'm still stuck with an en-US entry in the languages menu although I deleted /usr/share/myspell/dicts/??-??.{aff,dic} but the others are gone.)

Micah Gersten (micahg) wrote :

I'll should be attaching a branch soon with a patch for this that prevents Firefox from loading the other dictionary libraries.

Changed in firefox-3.5 (Ubuntu):
assignee: nobody → Micah Gersten (micahg)
Sigurd Gartmann (sigurdga) wrote :

I think era's patch solves half of the problem (I put a number 2 on it earlier). Era also says that we need to fix eacy myspell package. For bokmål norwegian and south-african english this is already done correct in my setup, with only one entry, and only one of each file (the standard underscore variant).

Will it be good enough to hope that all myspell packages are fixed, or should we have a patch excluding the "hyphen" links (or only including the standard files)? Will all myspell packages get fixed?

Micah: I saw you linked a branch to this bug, but I did only see changes to debian/patches/series, and not an added patch file. Am I missing something or just too eager to wait in silence?

era: I guess US english is a special case, like it is for the translated user interface. I do not know myspell details, but shouldn't new additions you make to your personal dictionaries be assigned to a language? If so, US-english may be that language even if it is removed from your system.

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Sorry, I forgot to add the patch file. It's there now. My patch
simply prevents Firefox from loading the dictionaries with underscores.

There's a test build in my Mozilla Test PPA:
https://launchpad.net/~micahg/+archive/mozilla-test

Sigurd Gartmann wrote:
> I think era's patch solves half of the problem (I put a number 2 on
> it earlier). Era also says that we need to fix eacy myspell
> package. For bokmål norwegian and south-african english this is
> already done correct in my setup, with only one entry, and only one
> of each file (the standard underscore variant).
>
> Will it be good enough to hope that all myspell packages are fixed,
> or should we have a patch excluding the "hyphen" links (or only
> including the standard files)? Will all myspell packages get fixed?
>
>
> Micah: I saw you linked a branch to this bug, but I did only see
> changes to debian/patches/series, and not an added patch file. Am I
> missing something or just too eager to wait in silence?
>
> era: I guess US english is a special case, like it is for the
> translated user interface. I do not know myspell details, but
> shouldn't new additions you make to your personal dictionaries be
> assigned to a language? If so, US-english may be that language even
> if it is removed from your system.
>
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)

iEYEARECAAYFAkqccjAACgkQTniv4aqX/VmQ5wCfccO1IREdJpeU1fRACEfzcq2k
+EkAn3FZvEPoPEkibV0JdKsoQ9YPDVzL
=iNqI
-----END PGP SIGNATURE-----

era (era) wrote :

On Tue, 01 Sep 2009 00:02 +0000, "Sigurd Gartmann"
<email address hidden> wrote:
> era: I guess US english is a special case, like it is for the translated
> user interface. I do not know myspell details, but shouldn't new
> additions you make to your personal dictionaries be assigned to a
> language? If so, US-english may be that language even if it is removed
> from your system.

Actually I was guessing it might have been lingering in some preferences
of mine and thus included in the list simply because of that.

I found that, surprisingly, more dictionaries had human-readable names
when I applied my patch, but this might be just something on my test
system. However, if that is a correct observation then perhaps changing
the separator would be preferable to suppressing the underscore variants
(or perhaps you could do both -- change the separator and suppress the
hyphen variants).

Figuring out whether it's okay to change all myspell dictionaries is
probably more work than can be done before Karmic, although I've
observed in other bugs a tendency to prefer "make it right" over "make
it work now". As such, I think suppressing the superfluous entries is a
kludge of the latter kind. But I'm not complaining. (-:

/* era */

--
If this were a real .signature, it would suck less. Well, maybe not.

era (era) wrote :

FWIW as of the Debian 5.0.1 (Lenny) Live CD, Iceweasel (the rebranded Firefox) in Debian has the same issue. The hyphenated dictionary links are installed by myspell-en-us and you get the underscored "en_US" as well as the hyphenated -> human-readable "English (United States)" in the menu. I could find no bug report for Debian about this, and cursory reading of the Debian Spelling Dictionaries and Tools Policy http://dict-common.alioth.debian.org/dsdt-policy.html also did not reveal anything about the practice of adding both hyphenated and underscored versions of each myspell dictionary.

User-Agent: Mozilla/5.0 (X11; U; Linux x86_64; en-US; rv:1.9.0.13) Gecko/2009080316 Ubuntu/8.10 (intrepid) Firefox/3.0.13
Build Identifier: Mozilla/5.0 (X11; U; Linux x86_64; en-US; rv:1.9.0.13) Gecko/2009080316 Ubuntu/8.10 (intrepid) Firefox/3.0.13

It seems that the code for finding spelling dictionaries in inlineSpellCheckUI.js expects nonstandard dictionary names. On Linux, most spelling dictionaries have a file name like lc_RC where lc = language code (e.g. "en") and RC = region code (e.g. "US"), separated by an underscore. By contrast, Mozilla expects the separator to be a hyphen.

On a Fedora 12 alpha Live CD, when you install hunspell-en (the dictionary pack for English for hunspell) you get a language menu with unreadable computer-ish names like "en_GB" and "en_US". On Windows (and Debian, because they have a workaround in place), you get human-readable names like "English / United Kingdom" and "English / United States" in the spelling dictionary language menu.

Reproducible: Always

Steps to Reproduce:
1. Navigate to a page with a <textarea> or other spell-checkable element
2. Type in some typos
3. Right-click in the textarea, and inspect the Languages > submenu in the menu you got when you right-clicked
Actual Results:
 en_AU
 en_ZA
 en_GB
 en_US

Expected Results:
 English / Australia
 English / South Africa
 English / United Kingdom
 English / United States

https://bugs.launchpad.net/ubuntu/+source/firefox/+bug/66015 is a related Ubuntu bug which has lots of triage notes (and also a fair amount of noise).

Note that Ubuntu inherited the Debian workaround, which has a problem (which is really the topic of the Ubuntu bug in question): it displays *both* the underscored names and the human-readable names.

This is supposed to be done by the fix in bug 335600 - why doesn't it work on Linux ?

> var isoStrArray = list[i].split("-");

This splits the lc and RC on hyphen, but if they are not hyphen-separated, it doesn't manage to split them properly. Most other tools on Linux (OpenOffice, for example) have the underscore as separator. So the problem isn't really in the code per se, but in the assumption that the dictionary file names will be using a hyphen between these parts.

(The Debian workaround is to install symlinks lc-RC -> lc_RC for each installed dictionary, but that has other problems, as mentioned above.)

My proposed fix would simply use an underscore and be done with it, but that requires Windows (and Mac?) dictionaries to be named according to the Linux / ISO convention. Who controls that, are the Windows and Mac spelling dictionaries distributed by Mozilla or by a third party? Or anyway, perhaps the code could use a different separator on different platforms, but I'm not enough versed in JavaScript to know how to do that elegantly and idiomatically. Or well, perhaps it can split on *either* hyphen or underscore, which should work with minimal fuss on all platforms.

(A crude patch is available as an attachment to the Launchpad bug linked above, but it's completely trivial.)

era (era) wrote :

I have also tried the Fedora 12 alpha and it doesn't come with any dictionaries out of the box. When I installed hunspell-en (F12 has FF3.5) I got underscored en_XX names only; apparently, no support for the hyphenated human-readable dictionary names at all.

era (era) on 2009-09-02
Changed in firefox:
importance: Undecided → Unknown
status: New → Unknown
Changed in firefox:
status: Unknown → New
Changed in firefox:
status: New → In Progress
Reed Loden (reed) on 2009-11-09
Changed in firefox-3.5 (Ubuntu):
assignee: Micah Gersten (micahg) → Reed Loden (reed)
Micah Gersten (micahg) on 2009-11-10
tags: added: fixed-3.7
removed: mt-upstream
Changed in firefox:
status: In Progress → Fix Released
Changed in thunderbird:
status: Unknown → New
Changed in thunderbird:
status: New → Confirmed
Micah Gersten (micahg) on 2009-11-17
Changed in thunderbird (Ubuntu):
importance: Undecided → Low
status: New → Triaged
Changed in dictionaries-common (Debian):
status: Unknown → New
Changed in dictionaries-common (Debian):
status: New → Fix Released
Micah Gersten (micahg) on 2009-11-26
Changed in firefox:
milestone: none → 3.7
Changed in hundredpapercuts:
milestone: round-9 → none
33 comments hidden view all 113 comments

Seems I don't have the privileges to add the necessary flags.

I was planning to ask for a review from bienvenu, with dmose as my planned fallback. You can do this by viewing the "details" link for the patch and selecting "review > ? > bienvenu". Maybe you should send email as well. See also https://developer.mozilla.org/en/Mailnews_and_Mail_code_review_requirements

As per the FAQ, as this is a fairly trivial change, I would like to suggest rubberstamping this ("requesting 'rs= '").

Sorry if I'm doing it wrong, this is my first time.

(From update of attachment 409292)
a192=beltzner

Micah Gersten (micahg) on 2009-12-02
Changed in firefox:
milestone: 3.7 → 3.6

Sr is needed for mailnews code and maybe for the editor code that needs to be changed (ain't sure on that one).

Sending an email is not required.

(From update of attachment 412560)
switching review to standard8 - I think he has linux available.

(From update of attachment 412560)
Sorry, my review queue is overloaded at the moment, I'm redirecting this to some others who are hopefully less loaded.

(From update of attachment 414001)
Approved for 1.9.1.8, a=dveditz for release-drivers

I think the code looks ok, but what do i have to build with for thunderbird to pick up those spell checking libraries? My normal builds only pick up what's shipped with tb.

(In reply to comment #14)
> I think the code looks ok, but what do i have to build with for thunderbird to
> pick up those spell checking libraries? My normal builds only pick up what's
> shipped with tb.

Ubuntu symlinks the dictionaries directory to /usr/share/myspell/dicts after install.

(From update of attachment 412560)
Ah, yeah works fine, thx! r=mkmelin

(From update of attachment 412560)
>diff -r e00dce0f3aaf suite/browser/metadata.js
>--- a/suite/browser/metadata.js Mon Nov 16 11:04:18 2009 +0100
>+++ b/suite/browser/metadata.js Mon Nov 16 13:27:07 2009 +0100
>@@ -462,7 +462,7 @@
> if (!abbr) return "";
> var result;
> var region = "";
>- var tokens = abbr.split("-");
>+ var tokens = abbr.split(/[-_]/);
RFC5646 seems to suggest that only "-" is legal, or am I overlooking something?
[Note that this question does not apply to the rest of the patch, as that apparently exists to work around Linux distros using non-RFC language codes.]

(In reply to comment #17)
> >- var tokens = abbr.split("-");
> >+ var tokens = abbr.split(/[-_]/);
> RFC5646 seems to suggest that only "-" is legal, or am I overlooking something?

Yeah, that part of the patch is just wrong. Should only be changing the parts that have to do with finding spelling dictionaries.

(From update of attachment 412560)
In that case, sr=me excluding the metadata.js changes.

Cristian: to get your patches checked in once reviewed, add checkin-needed to the keywords. I've added it now (I would check it in, but parts of the tree are closed).

Vish (vish) on 2010-01-16
Changed in hundredpapercuts:
status: Confirmed → Triaged

Christian,

Thank You VERY much for this patch. I just checked it in:

pushed as: http://hg.mozilla.org/comm-central/rev/efbc27606f4e

If you want this backported we can probably do that, just please provide a patch to do just that, there is the 1.9.1 branch (for TB3.0) I doubt we'll backport to TB2.0 though. (To get a patch backported it will need a new review if any changes are different then this last patch, and would need approval from a thunderbird driver)

(In reply to comment #21)
> Christian,
>
> Thank You VERY much for this patch. I just checked it in:
>
> pushed as: http://hg.mozilla.org/comm-central/rev/efbc27606f4e
>
> If you want this backported we can probably do that, just please provide a
> patch to do just that, there is the 1.9.1 branch (for TB3.0) I doubt we'll
> backport to TB2.0 though. (To get a patch backported it will need a new review
> if any changes are different then this last patch, and would need approval from
> a thunderbird driver)

Hello Justin,

Thanks a deal for checking this in. This patch (i.e. http://hg.mozilla.org/comm-central/raw-rev/efbc27606f4e) already applies cleanly to comm-1.9.1. What do I need to do in this case?

Micah Gersten (micahg) wrote :

firefox is the source package for Firefox 3.6, so reopening this task

Changed in firefox (Ubuntu):
status: Won't Fix → Triaged
Micah Gersten (micahg) wrote :

I think this was fixed in 1.4.0ubuntu1 in Lucid, but I have to verify, so marking Triaged.

Changed in dictionaries-common (Ubuntu):
importance: Undecided → Low
status: New → Triaged
assignee: nobody → Micah Gersten (micahg)

(From update of attachment 412560)
in that case, requesting approval is enough, I just did so.

Launchpad Janitor (janitor) wrote :
Download full text (9.6 KiB)

This bug was fixed in the package firefox - 3.6+nobinonly-0ubuntu1

---------------
firefox (3.6+nobinonly-0ubuntu1) lucid; urgency=low

  * New upstream release v3.6 (FIREFOX_3_6_RELEASE)
    + fix LP: #449744 - Firefox crashes when attempting to load Firebug 1.5
    + fix LP: #66015 - Duplicate spell checking dictionaries for every entry
    + fix LP: #132938 - tooltips dont work in sidebar
    + fix LP: #195698 - Password asked separately for each tab that requires it
                        (proxy)
    + fix LP: #239462 - tooltips disappear too fast
    + fix LP: #385816 - Resize corner grab stays visible after maximize
    + fix LP: #429476 - firefox crash on javascript page
    + fix LP: #432876 - Icons missing in Firefox searchbox drop down list
    + fix LP: #486284 - maxlength on input box can be overriden by autocomplete
    + fix LP: #501393 - Integrate Firefox notifications with notify-osd bling

  [ H. Montoliu <email address hidden> ]
  * fix LP: #361052 - firefox apport hook fails to retrieve pluginreg.dat file
  * update debian/apport/firefox-3.6.py - removed unused code and minor refactoring.

  [ Fabien Tassin <email address hidden> ]
  * Update the location of the upsteam branch now that 3.6/Namoroka has its own
    branch, and trunk moved on to 3.7
    - update debian/mozclient/firefox-3.6.conf
  * Use Namoroka instead of Shiretoko as brand name and use it for snapshots.
    Name it Namoroka in the Preferred Application UI too
    - update debian/firefox-3.6-shiretoko.desktop => debian/firefox-3.6-namoroka.desktop
    - update debian/firefox-3.6.xml
    - update debian/rules
  * Target the 'default' branch instead of tip
    - add debian/moz-rev.sh
    - update debian/mozclient/firefox-3.6.conf
  * Add firefox 3.6 to the list of Preferred Applications in Gnome
    - add debian/firefox-3.6.xml
    - update debian/firefox-3.6-gnome-support.install
  * Add ${misc:Depends} to all non-transitional packages, make firefox-3.6-dbg
    depend on firefox-3.6 with the exact same version, move -dbg packges to
    priority extra and add firefox-3.6-gnome-support-dbg
    - update debian/control
  * Update diverged patches:
    - update debian/patches/browser_branding.patch
    - update debian/patches/firefox-profilename
    - update debian/patches/ubuntu_bookmarks.patch
    - update debian/patches/lp185622_system_path_default_browser.patch
    - update debian/patches/dont_depend_on_nspr_sources.patch

  [ Alexander Sack <email address hidden> ]
  * add libnotify-dev to build-depends
    - update debian/control
  * add libiw-dev to build-depends to fix build failure
    - update debian/control
  * until we move searchplugins to a separate package provided only by the current default
    firefox, we need to make firefox-3.6 replace all the older firefox binary packages:
    firefox-3.5, firefox-3.2, firefox-3.1, firefox-3.0
    - update debian/control
  * implement MIN_SYS_DEPS approach that does not use system xulrunner
    and only a minimal set of system dependencies.
    + drop patches not required anymore:
      - delete debian/patches/dont_depend_on_nspr_sources.patch
      - update debian/patches/series
    + update browser directory provider...

Read more...

Changed in firefox (Ubuntu):
status: Triaged → Fix Released

(In reply to comment #21)
> Thank You VERY much for this patch. I just checked it in:
>
> pushed as: http://hg.mozilla.org/comm-central/rev/efbc27606f4e

If a bug is fixed on trunk, please ensure that it is marked as such. Branch patches are tracked in a different status field as described here:

https://wiki.mozilla.org/Thunderbird/Thunderbird3_Security_And_Stability_Releases#General_Process_for_landing_bugs_on_Thunderbird_3.0.x

(In reply to comment #24)
> (In reply to comment #21)
> > Thank You VERY much for this patch. I just checked it in:
> >
> > pushed as: http://hg.mozilla.org/comm-central/rev/efbc27606f4e
>
> If a bug is fixed on trunk, please ensure that it is marked as such. Branch
> patches are tracked in a different status field as described here:
>
> https://wiki.mozilla.org/Thunderbird/Thunderbird3_Security_And_Stability_Releases#General_Process_for_landing_bugs_on_Thunderbird_3.0.x

I think in this case I only left open as I was not sure if this patch fixed the entire bug or if it was a partial; but thank you for pointing out the doc again. I of course should have error-ed on my gut feeling here.

Changed in thunderbird:
status: Confirmed → Fix Released

(From update of attachment 412560)
Note: the a=Standard8 is also for the SeaMonkey part of the patch here.

Tor Klingberg (tor-klingberg) wrote :

I tried deleting the symlinks en-US.aff and en-US.dic in /usr/share/myspell/dicts and restart Firefox, but there are still two languages: "en_US" and "English / United States"

/usr/share/myspell/dicts$ ls
backup DicOOo.sxw en_US.aff en_US.dic hyph_en_US.dic

Daniel Cordeiro (dcordeiro) wrote :

I'm still having this problem with the latest Firefox in Lucid (Version: 3.6+nobinonly-0ubuntu6), but it doesn't happen with all entries.

I have the Portuguese, French and English language packs and I see some languages duplicated: "English / United States", "English / Australia", "Portuguese / Brazil", etc.

I'm attaching a screenshot of my dictionary options.

RubenKwast (rubenkwast) wrote :

Same thing as Daniel. Updated to Lucid and running 3.6.2. Not all languages are duplicated, but some are.

Also, where can remove languages from my list? I just want en_US in there, not the Australian and South African version...

Daniel, Ruben .. that's not what this bug is about.

In the past, there were two links for every dictionary file installed.
You guys are complaining about the fact that there are dictionaries installed that you don't need/want.

But that should be a different bug report and concerns completely different packages.
This bug is fixed.

Benjamin Drung (bdrung) wrote :

I doubt that this bug is fixed. I still see everything twice (screenshot attached) with firefox 3.6.2+nobinonly-0ubuntu1.

The one piece that is not fixed is dictionaries-common. I'll look into
it if I can before release.

On 04/02/2010 05:34 PM, Benjamin Drung wrote:
> I doubt that this bug is fixed. I still see everything twice (screenshot
> attached) with firefox 3.6.2+nobinonly-0ubuntu1.
>
> ** Attachment added: "languages-twice.png"
> http://launchpadlibrarian.net/42925479/languages-twice.png
>
>

Micah Gersten (micahg) wrote :

Firefox part fixed with 3.5.8

Changed in firefox-3.5 (Ubuntu):
assignee: Reed Loden (reed) → nobody
status: Triaged → Fix Released
Cristian Klein (cristiklein) wrote :

On 03/04/2010 00:42, Micah Gersten wrote:
> The one piece that is not fixed is dictionaries-common. I'll look into
> it if I can before release.

I think the problem is (also) in the igerman98 source package.
debian/rules creates the unneeded symlinks at line 116.

Cristian Klein (cristiklein) wrote :

On 02/04/2010 13:57, RubenKwast wrote:
> Also, where can remove languages from my list? I just want en_US in
> there, not the Australian and South African version...

A very ugly way is to go in the /usr/share/myspell/dicts folder and
manually delete the dictionaries you don't need, then restart Firefox.

Vish (vish) wrote :

Micah , hope you get time to check this for Maverick :)

Changed in hundredpapercuts:
milestone: none → maverick-round-8-potpourri
Micah Gersten (micahg) wrote :

This was addressed for Thunderbird in bug #590452. Please file separate bugs if you see any duplicates in Maverick.

Changed in thunderbird (Ubuntu):
status: Triaged → Fix Released
Micah Gersten (micahg) wrote :

No change was needed in Ubuntu for dictionaries-common, so marking invalid.

Changed in dictionaries-common (Ubuntu):
assignee: Micah Gersten (micahg) → nobody
status: Triaged → Invalid
Vish (vish) wrote :

Thanks Micah for tracking this down! :-)

Changed in hundredpapercuts:
status: Triaged → Fix Released
Changed in firefox:
importance: Unknown → Medium
Changed in thunderbird:
importance: Unknown → Medium
Oleg Moiseichuk (berroll) wrote :

It seems that Thunderbird and Firefox now correctly recognize ln_RE file names for the dictionaries (in Lucid at least). The problem is that they also recognize ln-RE names and this causes duplication of entries in the list of supported dictionaries.
I fixed this by removing all files with hyphen by 'sudo rm ??-*' from /usr/share/myspell/dicts/ and /usr/share/hunspell/ (as all dictionaries in myspell folder have links to hunspell). You can backup these files instead of removing them if you wish to play safe, but files ln_RE.* and ln-RE.* are duplicates.
I checked OpenOffice and both TB and FF - spell checking works normally everywhere and Mozilla products now have only single entry for each language. (I'm using Ubuntu Lucid, FF 3.6.13, TB 3.1.7)

firefox 9.0.1+build1-0ubuntu0.10.04.1

alexandre$ ls -la /usr/share/myspell/dicts/
total 129
drwxr-xr-x 2 root root 1088 2011-02-03 06:28 .
drwxr-xr-x 4 root root 96 2008-07-02 07:36 ..
-rw-r--r-- 1 root root 129761 2011-01-26 23:31 DicOOo.sxw
lrwxrwxrwx 1 root root 24 2010-05-07 04:34 en_AU.aff -> ../../hunspell/en_AU.aff
lrwxrwxrwx 1 root root 24 2010-05-07 04:34 en-AU.aff -> ../../hunspell/en-AU.aff
lrwxrwxrwx 1 root root 24 2010-05-07 04:34 en_AU.dic -> ../../hunspell/en_AU.dic
lrwxrwxrwx 1 root root 24 2010-05-07 04:34 en-AU.dic -> ../../hunspell/en-AU.dic
lrwxrwxrwx 1 root root 24 2010-08-09 17:38 en_CA.aff -> ../../hunspell/en_CA.aff
lrwxrwxrwx 1 root root 24 2010-08-09 17:38 en_CA.dic -> ../../hunspell/en_CA.dic
lrwxrwxrwx 1 root root 24 2010-08-09 17:38 en_GB.aff -> ../../hunspell/en_GB.aff
lrwxrwxrwx 1 root root 24 2010-08-09 17:38 en-GB.aff -> ../../hunspell/en_GB.aff
lrwxrwxrwx 1 root root 24 2010-08-09 17:38 en_GB.dic -> ../../hunspell/en_GB.dic
lrwxrwxrwx 1 root root 24 2010-08-09 17:38 en-GB.dic -> ../../hunspell/en_GB.dic
lrwxrwxrwx 1 root root 24 2010-05-07 04:31 en_US.aff -> ../../hunspell/en_US.aff
lrwxrwxrwx 1 root root 24 2010-05-07 04:31 en-US.aff -> ../../hunspell/en_US.aff
lrwxrwxrwx 1 root root 24 2010-05-07 04:31 en_US.dic -> ../../hunspell/en_US.dic
lrwxrwxrwx 1 root root 24 2010-05-07 04:31 en-US.dic -> ../../hunspell/en_US.dic
lrwxrwxrwx 1 root root 24 2010-08-09 17:38 en_ZA.aff -> ../../hunspell/en_ZA.aff
lrwxrwxrwx 1 root root 24 2010-08-09 17:38 en_ZA.dic -> ../../hunspell/en_ZA.dic
lrwxrwxrwx 1 root root 27 2010-05-07 04:44 hyph_en_CA.dic -> ../../hyphen/hyph_en_CA.dic
lrwxrwxrwx 1 root root 27 2010-05-07 04:44 hyph_en_GB.dic -> ../../hyphen/hyph_en_GB.dic
lrwxrwxrwx 1 root root 27 2010-05-07 04:44 hyph_pt_BR.dic -> ../../hyphen/hyph_pt_BR.dic
lrwxrwxrwx 1 root root 27 2010-05-07 04:44 hyph_pt_PT.dic -> ../../hyphen/hyph_pt_PT.dic
lrwxrwxrwx 1 root root 21 2010-05-07 04:34 pt.aff -> ../../hunspell/pt.aff
lrwxrwxrwx 1 root root 24 2010-05-07 04:34 pt_BR.aff -> ../../hunspell/pt_BR.aff
lrwxrwxrwx 1 root root 24 2010-05-07 04:34 pt-BR.aff -> ../../hunspell/pt_BR.aff
lrwxrwxrwx 1 root root 24 2010-05-07 04:34 pt_BR.dic -> ../../hunspell/pt_BR.dic
lrwxrwxrwx 1 root root 24 2010-05-07 04:34 pt-BR.dic -> ../../hunspell/pt_BR.dic
lrwxrwxrwx 1 root root 21 2010-05-07 04:34 pt.dic -> ../../hunspell/pt.dic
lrwxrwxrwx 1 root root 21 2010-05-07 04:34 pt-PT.aff -> ../../hunspell/pt.aff
lrwxrwxrwx 1 root root 21 2010-05-07 04:34 pt-PT.dic -> ../../hunspell/pt.dic
lrwxrwxrwx 1 root root 28 2010-05-07 04:42 th_en_AU_v2.dat -> ../../mythes/th_en_AU_v2.dat
lrwxrwxrwx 1 root root 28 2010-05-07 04:42 th_en_AU_v2.id -> ../../mythes/th_en_AU_v2.idx
lrwxrwxrwx 1 root root 28 2010-08-09 17:38 th_en_US_v2.dat -> ../../mythes/th_en_US_v2.dat
lrwxrwxrwx 1 root root 28 2010-08-09 17:38 th_en_US_v2.idx -> ../../mythes/th_en_US_v2.idx

Those files (symbolic links) with a hyphen are there for a reason. I have no courage to simply remove them. Firefox should deal with them then?

Displaying first 40 and last 40 comments. View all 113 comments or add a comment.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.